/**
 * Copyright (C) 2006-2011 Takanori Amano, Amax Inc., and Connectone Co.,Ltd.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jp.co.connectone.webapps.helpers;

import jp.co.connectone.store.pim.*;
import jp.co.connectone.eai.notes.store.NotesDJXAddressDTO;

public class NotesDJXWebAddressParseHelper extends WebAddressParseHelper {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public NotesDJXWebAddressParseHelper(IAddressDTO dto) {
		super(new AddressParseHelper(dto));
		if(dto instanceof NotesDJXAddressDTO) {
			djxDisplayName = ((NotesDJXAddressDTO)dto).getDjxDisplayName();
		}
	}		
	public NotesDJXWebAddressParseHelper(AddressParseHelper org) {
		super(org);
	}
	public String getDisplayName() {
		if(djxDisplayName != null) {
			return djxDisplayName + "(" + super.getDisplayName() + ")";
		}
		return super.getDisplayName();
	}
	protected String djxDisplayName;
}
