/**
 * Copyright (C) 2006-2011 Takanori Amano, Amax Inc., and Connectone Co.,Ltd.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jp.co.connectone.store.pim;

import java.util.Comparator;
import java.util.Date;


public class IScheduleParseHelperComparator implements Comparator<ScheduleParseHelper>
{
	public static final int SUBJECT=0;
	public static final int STARTDATETIME=1;
	public static final int ENDDATETIME=2;
	private int sortKey=0;
	private boolean reverce=false;
	public IScheduleParseHelperComparator(int sortKey,boolean isReverce)
	{
		this.sortKey = sortKey;
		this.reverce = isReverce;
	}

	public int compare(ScheduleParseHelper src, ScheduleParseHelper dst)
	{
		if (src==null) {
			return 0;
		}
		if (dst==null) {
			return 0;
		}
		switch (sortKey) {
		case SUBJECT:
			String s1 = src.getSubject();
			String s2 = dst.getSubject();
			if (reverce) {
				return s2.compareTo(s1);
			}
			else {
				return s1.compareTo(s2);
			}
		case STARTDATETIME:
			Date d1 = src.getStartDate();
			Date d2 = dst.getStartDate();
			if (reverce) {
				return d2.compareTo(d1);
			}
			else {
				return d1.compareTo(d2);
			}
		case ENDDATETIME:
			d1 = src.getEndDate();
			d2 = dst.getEndDate();
			if (reverce) {
				return d2.compareTo(d1);
			}
			else {
				return d1.compareTo(d2);
			}
		}
		
		return 0;
	}

}
